Index: src/rtgsqlbuf.c
===========================================================================
*** /dev/null	Wed Nov  3 14:22:00 2004
--- src/rtgsqlbuf.c	Wed Nov  3 14:26:19 2004
***************
*** 0 ****
--- 1,476 ----
+ /*
+  * (c) 2004 bill fumerola, yahoo!
+  * 
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 
+  * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $Yahoo: //depot/fumerola/rtg-contrib/src/rtgsqlbuf.c#12 $
+  */
+ 
+ #include <mysql/errmsg.h>
+ #include "common.h"
+ #include "rtg.h"
+ #include "rtgsqlbuf.h"
+ 
+ #define	SQLBUF_TOILET	0x01
+ #define	SQLBUF_MASK	0x01
+ 
+ struct sqlbuf {
+ 	char *table;
+ 	char *buffer, *currbuf;
+ 	unsigned short flags;
+ 	unsigned int pfxlen;	/* length of query up to the values */
+ 	unsigned int currlen;	/* current length of buffer */
+ 	unsigned int datalen;	/* length of an individual datum */
+ 	unsigned int currcnt;	/* current count of datums */
+ 	unsigned int roundcnt;	/* count of possible datums per round */
+ 	RTGLL_ENTRY(sqlbuf) next;
+ 	RTGLL_ENTRY(sqlbuf) flush;
+ 	pthread_mutex_t mutex;
+ };
+ 
+ static struct {
+ 	RTGLL_HEAD(, sqlbuf) head; 
+ 	pthread_mutex_t mutex;
+ } sbufh;
+ 
+ /*
+  * sqlbufs that must to be flushed or at least resized before the next round
+  */
+ static struct {
+ 	unsigned int count;
+ 	RTGLL_HEAD(, sqlbuf) head; 
+ 	pthread_cond_t empty;
+ 	pthread_mutex_t swirl;
+ } toilet;
+ 
+ static struct {
+ #if HAVE_MYSQL
+ 	MYSQL *mysql;
+ #elif HAVE_PGSQL
+ #warning pgsql sqlbuf not yet implemented
+ #endif
+ 	pthread_mutex_t mutex;
+ } dbh;
+ 
+ static unsigned int maxbuf;
+ static enum { FLUSH_WAITING, FLUSH_SWIRLING, FLUSH_SIGNALING } flushing;
+ static pthread_t plumber_thread;
+ static void *plumber(void *arg);
+ 
+ /* sqlbuf_cfg_all(): teach all sqlbufs about table column sizes */
+ static void sqlbuf_cfg_all(void);
+ /* sqlbuf_flush1(): database-indepedent flush of the data in 'sbuf' */
+ static __inline void sqlbuf_flush1(struct sqlbuf *sbuf);
+ /* sqlbuf_flush_all(): flush all sqlbufs in system */
+ static void sqlbuf_flush_all(void);
+ /* sqlbuf_flush_mysql(): database-dependent flush of the data in 'sbuf' */
+ static void sqlbuf_flush_mysql(struct sqlbuf *sbuf, MYSQL *mysql);
+ /* sqlbuf_mysql_cfg(): configure 'sbuf' to get field info */
+ static void sqlbuf_mysql_cfg(struct sqlbuf *sbuf);
+ /* sqlbuf_realloc(): resize 'sbuf' to hold 'size' rows */
+ static int sqlbuf_realloc(struct sqlbuf *sbuf, unsigned int size);
+ /* sqlbuf_reset(): clear and forget any unflushed data in 'sbuf' */
+ static void sqlbuf_reset(struct sqlbuf *sbuf);
+ 
+ /* sqlbuf_flush1() is always called with a locked sqlbuf */
+ static __inline void
+ sqlbuf_flush1(struct sqlbuf *sbuf)
+ {
+ 
+ 	if (sbuf->currcnt == 0 || sbuf->buffer == NULL) {
+ 		debug(DEVELOP, "skipping %s with %u buffers\n", sbuf->table,
+ 		    sbuf->currcnt);
+ 		return;
+ 	}
+ 	SPT("inserting into %s", sbuf->table);
+ #if HAVE_MYSQL
+ 	sqlbuf_flush_mysql(sbuf, dbh.mysql);
+ #elif HAVE_PGSQL
+ #endif
+ 	SPT("done inserting into %s", sbuf->table);
+ }
+ 
+ /* sqlbuf_flush_mysql() is always called with a locked sqlbuf */
+ static void
+ sqlbuf_flush_mysql(struct sqlbuf *sbuf, MYSQL *mysql)
+ {
+ 	MYSQL_RES *res;
+ 	unsigned long long rows;
+ 	unsigned int myerrno;
+ 	const char *myerror;
+ 
+ 	sbuf->buffer[sbuf->currlen - 1] = '\0';
+ 	debug(DEBUG, "FLUSHING %s: %s\n", sbuf->table, sbuf->buffer);
+ 	PT_MUTEX_LOCK(&dbh.mutex);
+ 	if (mysql_query(mysql, sbuf->buffer)) {
+ 		myerrno = mysql_errno(mysql);
+ 		myerror = mysql_error(mysql);
+ 		PT_MUTEX_UNLOCK(&dbh.mutex);
+ 		switch (myerrno) {
+ 		case CR_SERVER_GONE_ERROR:
+ 		case CR_SERVER_LOST:
+ 		case CR_CONN_HOST_ERROR:
+ 			debug(LOW, "*** mysql unavailable (%u), buffering\n",
+ 			    myerrno);
+ 			/* 
+ 			 * if the allocation succeeds: tack a comma back on the
+ 			 * end of the buffer and resume queueing.
+ 			 * if the allocation fails: reset and hope for better
+ 			 * days.
+ 			 */
+ 			if (sqlbuf_realloc(sbuf, sbuf->currlen +
+ 			   (sbuf->roundcnt * sbuf->datalen * 2))) {
+ 				sbuf->buffer[sbuf->currlen - 1] = ',';
+ 				return;
+ 			}
+ 			break;
+ 		default:
+ 			debug(LOW, "*** mysql flush error %u: %s\n", myerrno,
+ 			    myerror);
+ 			break;
+ 		}
+ 		sqlbuf_reset(sbuf);
+ 		return;
+ 	}
+ 	res = mysql_store_result(mysql);
+ 	rows = mysql_affected_rows(mysql);
+ 	mysql_free_result(res);
+ 	PT_MUTEX_UNLOCK(&dbh.mutex);
+ 	if (rows) {
+ 		PT_MUTEX_LOCK(&stats.mutex);
+ 		stats.db_inserts += rows;
+ 		PT_MUTEX_UNLOCK(&stats.mutex);
+ 	}
+ 	if (sbuf->currcnt != rows) {
+ 		debug(LOW, "*** table %s: %u rows queued, inserted %llu\n",
+ 		    sbuf->table, sbuf->currcnt, rows);
+ 	}
+ 	/* 
+ 	 * shrink down buffer if we had to grow it
+ 	 * if the realloc fails, the reset will still work.
+ 	 */
+ 	if (sbuf->roundcnt < sbuf->currcnt) {
+ 		sqlbuf_realloc(sbuf, (sbuf->roundcnt * sbuf->datalen * 2) +
+ 		    sbuf->pfxlen);
+ 	}
+ 	sqlbuf_reset(sbuf);
+ }
+ 
+ static void
+ sqlbuf_flush_all(void)
+ {
+ 	struct sqlbuf *tbuf;
+ 
+ 	PT_MUTEX_LOCK(&sbufh.mutex);
+ 	RTGLL_FOREACH(tbuf, &sbufh.head, next) {
+ 		PT_MUTEX_LOCK(&tbuf->mutex);
+ 		sqlbuf_flush1(tbuf);
+ 		PT_MUTEX_UNLOCK(&tbuf->mutex);
+ 	}
+ 	PT_MUTEX_UNLOCK(&sbufh.mutex);
+ }
+ 
+ void
+ sqlbuf_free(struct sqlbuf *sbuf)
+ {
+ 
+ 	debug(DEVELOP, "SQLBUF: retiring sqlbuf %s\n", sbuf->table);
+ 	PT_MUTEX_LOCK(&sbuf->mutex);
+ 	PT_MUTEX_LOCK(&sbufh.mutex);
+ 	RTGLL_REMOVE(&sbufh.head, sbuf, sqlbuf, next);
+ 	PT_MUTEX_UNLOCK(&sbufh.mutex);
+ 	free(sbuf->table);
+ 	if (sbuf->buffer)
+ 		free(sbuf->buffer);
+ 	PT_MUTEX_UNLOCK(&sbuf->mutex);
+ 	if (pthread_mutex_destroy(&sbuf->mutex))
+ 		fatal("cannot destroy mutex for %s\n", sbuf->table);
+ 	free(sbuf);
+ }
+ 
+ struct sqlbuf *
+ sqlbuf_create(const char *table)
+ {
+ 	struct sqlbuf *tbuf = NULL;
+ 	char prefix[256];
+ 
+ 	tbuf = calloc(1, sizeof(struct sqlbuf));
+ 	tbuf->table = strdup(table);
+ 	if (tbuf == NULL)
+ 		exit(1);
+ 	tbuf->pfxlen = sprintf(prefix, "INSERT DELAYED INTO %s VALUES ", table);
+ 	if (tbuf->pfxlen == 0)
+ 		exit(1);
+ 	tbuf->buffer = strdup(prefix);
+ 	if (tbuf->buffer == NULL)
+ 		exit(1);
+ 	tbuf->currbuf = NULL;
+ 	if (pthread_mutex_init(&tbuf->mutex, NULL))
+ 		fatal("cannot init mutex for %s\n", table);
+ 	sqlbuf_reset(tbuf);
+ 	PT_MUTEX_LOCK(&sbufh.mutex);
+ 	debug(DEVELOP, "SQLBUF: inserting sqlbuf %s\n", table);
+ 	RTGLL_INSERT_HEAD(&sbufh.head, tbuf, next);
+ 	PT_MUTEX_UNLOCK(&sbufh.mutex);
+ 	if (maxbuf)
+ 		sqlbuf_mysql_cfg(tbuf);
+ 
+ 	return (tbuf);
+ }
+ 
+ /* sqlbuf_mysql_cfg() is always called with a locked sbuf */
+ static void
+ sqlbuf_mysql_cfg(struct sqlbuf *sbuf)
+ {
+ 	MYSQL_RES *mres;
+ 	MYSQL_FIELD *field;
+ 	unsigned int cnt, dlen;
+ 
+ 	if (sbuf->datalen)
+ 		return;
+ 
+ 	PT_MUTEX_LOCK(&dbh.mutex);
+ 	/* size the individual value groups */
+ 	mres = mysql_list_fields(dbh.mysql, sbuf->table, NULL);
+ 	if (mysql_errno(dbh.mysql)) {
+ 		debug(LOW, "failed to configure %s (%s), skipping\n",
+ 			   sbuf->table, mysql_error(dbh.mysql));
+ 		free(sbuf->buffer);
+ 		sbuf->buffer = NULL;
+ 		PT_MUTEX_UNLOCK(&dbh.mutex);
+ 		return;
+ 	}
+ 	dlen = 17; /*strlen("()") + strlen("FROM_UNIXTIME()")*/;
+ 	for (cnt = 0; (field = mysql_fetch_field(mres)); cnt++)
+ 		dlen += field->length + 2 /* '' */ + 1 /* , */;
+ 	mysql_free_result(mres);
+ 	PT_MUTEX_UNLOCK(&dbh.mutex);
+ 	sbuf->datalen = dlen;
+ 	sqlbuf_reset(sbuf);
+ }
+ 
+ static void
+ sqlbuf_cfg_all(void)
+ {
+ 	struct sqlbuf *tbuf;
+ 
+ 	PT_MUTEX_LOCK(&sbufh.mutex);
+ 	RTGLL_FOREACH(tbuf, &sbufh.head, next) {
+ 		PT_MUTEX_LOCK(&tbuf->mutex);
+ #if HAVE_MYSQL
+ 		sqlbuf_mysql_cfg(tbuf);
+ #elif HAVE_PGSQL
+ #endif
+ 		PT_MUTEX_UNLOCK(&tbuf->mutex);
+ 	}
+ 	PT_MUTEX_UNLOCK(&sbufh.mutex);
+ }
+ 
+ void
+ sqlbuf_init(void)
+ {
+ 
+ 	RTGLL_INIT(&sbufh.head);
+ 	RTGLL_INIT(&toilet.head);
+ 	if (pthread_mutex_init(&sbufh.mutex, NULL))
+ 		fatal("cannot init sqlbuf system mutex\n");
+ 	if (pthread_mutex_init(&toilet.swirl, NULL))
+ 		fatal("cannot init end of flush mutex\n");
+ 	if (pthread_cond_init(&toilet.empty, NULL))
+ 		fatal("cannot init toilet empty condition variable\n");
+ 	if (pthread_mutex_init(&dbh.mutex, NULL))
+ 		fatal("cannot init database handle mutex\n");
+ 	if (pthread_create(&plumber_thread, NULL, plumber, NULL))
+ 		fatal("cannot create plumber thread\n");
+ }
+ 
+ /* 
+  * run once, after sqlbuf_init() and targets have been read in to
+  * initialize database dependent system
+  */ 
+ void
+ sqlbuf_db_mysql(MYSQL *mysql)
+ {
+ 	MYSQL_RES *mres;
+ 	MYSQL_ROW row;
+ 
+ 	if (mysql_query(mysql, "show variables like 'max_allowed_packet'"))
+ 		fatal("*** max_allowed_packet err: %s\n", mysql_error(mysql));
+ 
+ 	mres = mysql_store_result(mysql);
+ 	row = mysql_fetch_row(mres);
+ 	maxbuf = atoi(row[1]);
+ 	mysql_free_result(mres);
+ 
+ 	dbh.mysql = mysql;
+ 	sqlbuf_cfg_all();
+ }
+ 
+ void
+ sqlbuf_push(struct sqlbuf *sbuf, const char *data)
+ {
+ 	size_t dlen;
+ 
+ 	if (sbuf->buffer == NULL)
+ 		return;
+ 
+ 	PT_MUTEX_LOCK(&sbuf->mutex);
+ 	dlen = strlen(data);
+ 	if ((dlen + sbuf->currlen) > maxbuf)
+ 		sqlbuf_flush1(sbuf);
+ 	bcopy(data, sbuf->currbuf, dlen);
+ 	sbuf->currbuf += dlen;
+ 	*(sbuf->currbuf) = '\0';
+ 	sbuf->currlen += dlen;
+ 	sbuf->currcnt++;
+ 	/*
+ 	 * add any buffering sqlbuf to the top of the flush queue
+ 	 */
+ 	if (sbuf->currcnt >= sbuf->roundcnt &&
+ 	    (sbuf->flags ^ SQLBUF_TOILET) &&
+ 	    !pthread_mutex_trylock(&toilet.swirl)) {
+ 		RTGLL_INSERT_HEAD(&toilet.head, sbuf, flush);
+ 		toilet.count++;
+ 		sbuf->flags |= SQLBUF_TOILET;
+ 		PT_MUTEX_UNLOCK(&toilet.swirl);
+ 	}
+ 	debug(DEVELOP, "added '%s'[%u] %s\nbuffer now '%s'[%u]\n", data, dlen,
+ 		sbuf->table, sbuf->buffer, sbuf->currlen);
+ 	PT_MUTEX_UNLOCK(&sbuf->mutex);
+ }
+ 
+ static void
+ sqlbuf_reset(struct sqlbuf *sbuf)
+ {
+ 
+ 	sbuf->currbuf = sbuf->buffer + sbuf->pfxlen;
+ 	*(sbuf->currbuf) = '\0';
+ 	sbuf->currlen = sbuf->pfxlen;
+ 	sbuf->currcnt = 0;
+ }
+ 
+ static int
+ sqlbuf_realloc(struct sqlbuf *sbuf, unsigned int size)
+ {
+ 	char *newbuf;
+ 
+ 	newbuf = realloc(sbuf->buffer, size);
+ 	if (newbuf == NULL) {
+ 		debug(LOW, "cannot reallocate memory for %s\n", sbuf->table);
+ 		return (FALSE);
+ 	}
+ 	sbuf->buffer = newbuf;
+ 	sbuf->currbuf = sbuf->buffer + sbuf->currlen;
+ 	return (TRUE);
+ }
+ 
+ void
+ sqlbuf_resize(struct sqlbuf *sbuf, unsigned int n)
+ {
+ 
+ 	if (n == 0)
+ 		return;
+ 
+ 	PT_MUTEX_LOCK(&sbuf->mutex);
+ 
+ 	if (sbuf->roundcnt == n || sbuf->buffer == NULL || sbuf->datalen == 0) {
+ 		PT_MUTEX_UNLOCK(&sbuf->mutex);
+ 		return;
+ 	}
+ 	sbuf->roundcnt = n;
+ 	/* 
+ 	 * if we're holding onto more buffers than are needed for a round
+ 	 * we cannot shrink the buffer without losing data. attempt to flush.
+ 	 * if the flush succeeds the buffer will come back resized.
+ 	 * if the flush fails, the sqlbuf will be reset and will still
+ 	 * hold as many rows as needed for the next poll round.
+ 	 *
+ 	 * if we are unable to reallocate a larger buffer, flush the buffer.
+ 	 * if the flush fails remove the sbuf for now.
+ 	 */
+ 	if (sbuf->roundcnt < sbuf->currcnt)
+ 		sqlbuf_flush1(sbuf);
+ 	else if (!sqlbuf_realloc(sbuf, sbuf->pfxlen + (sbuf->datalen * n * 2))) {
+ 		sqlbuf_flush1(sbuf);
+ 		if (sbuf->currcnt) {
+ 			syslogcrit("SQLBUF: unable to flush or resize %s\n",
+ 			    sbuf->table);
+ #if 0
+ 			sbuf->roundcnt = sbuf->currcnt;
+ 			sqlbuf_reset(sbuf);
+ #endif
+ 			sbuf->buffer = NULL;
+ 		}
+ 	}
+ 	PT_MUTEX_UNLOCK(&sbuf->mutex);
+ }
+ 
+ static void *
+ plumber(void *arg /*unused*/)
+ {
+ 
+ 	for (;;) {
+ 		SPT("waiting for sqlbufs to process");
+ 		debug(DEBUG, "PLUMB: waiting for signal\n");
+ 
+ 		PT_MUTEX_LOCK(&toilet.swirl);
+ 		flushing = FLUSH_WAITING;
+ 		while (flushing == FLUSH_WAITING)
+ 			PT_COND_WAIT(&toilet.empty, &toilet.swirl);
+ 		flushing = FLUSH_SWIRLING;
+ 		PT_MUTEX_UNLOCK(&toilet.swirl);
+ 
+ 		debug(DEBUG, "PLUMB: flushing all bufs\n");
+ 		SPT("background flushing all sqlbufs");
+ 		sqlbuf_flush_all();
+ 
+ 		PT_MUTEX_LOCK(&stats.mutex);
+ 		debug(LOW, "[DBInserts = %llu]\n", stats.db_inserts);
+ 		PT_MUTEX_UNLOCK(&stats.mutex);
+ 		pthread_testcancel();
+ 	}
+ 	/* NOTREACHED */
+ 	pthread_exit(NULL);
+ }
+ 
+ void
+ sqlbuf_flush(void)
+ {
+ 	struct sqlbuf *tbuf;
+ 
+ 	debug(THREAD, "PLUMB: flushing %u sqlbufs\n", toilet.count);
+ 	PT_MUTEX_LOCK(&toilet.swirl);
+ 	while (toilet.count) {
+ 		tbuf = RTGLL_FIRST(&toilet.head);
+ 		PT_MUTEX_LOCK(&tbuf->mutex);
+ 		sqlbuf_flush1(tbuf);
+ 		RTGLL_REMOVE_HEAD(&toilet.head, flush);
+ 		tbuf->flags &= ~SQLBUF_TOILET;
+ 		PT_MUTEX_UNLOCK(&tbuf->mutex);
+ 		toilet.count--;
+ 	}
+ 	if (flushing == FLUSH_WAITING) {
+ 		flushing = FLUSH_SIGNALING;
+ 		PT_COND_SIGNAL(&toilet.empty);
+ 	}
+ 	PT_MUTEX_UNLOCK(&toilet.swirl);
+ }
Index: src/rtgsqlbuf.h
===========================================================================
*** /dev/null	Wed Nov  3 14:22:00 2004
--- src/rtgsqlbuf.h	Wed Nov  3 14:26:19 2004
***************
*** 0 ****
--- 1,46 ----
+ /*
+  * (c) 2004 bill fumerola, yahoo!
+  * 
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 
+  * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  * $Yahoo: //depot/fumerola/rtg-contrib/src/rtgsqlbuf.h#8 $
+  */
+ 
+ #include "rtglist.h"
+ #include "common.h"
+ 
+ struct sqlbuf;
+ 
+ /* sqlbuf_create(): allocate an sqlbuf for 'table' */
+ struct sqlbuf *sqlbuf_create(const char *table);
+ /* sqlbuf_db_mysql(): initialize system based on the connection 'mysql' */
+ void sqlbuf_db_mysql(MYSQL *mysql);
+ /* sqlbuf_flush(): flush all buffers */
+ void sqlbuf_flush(void);
+ /* sqlbuf_free(): remove 'sbuf' and free associated memory */
+ void sqlbuf_free(struct sqlbuf *sbuf);
+ /* sqlbuf_init(): initialize the sqlbuf system */
+ void sqlbuf_init(void);
+ /* sqlbuf_push(): push 'data' into 'sbuf' possibly using 'dbh' to flush */
+ void sqlbuf_push(struct sqlbuf *sbuf, const char *data);
+ /* sqlbuf_resize(): reallocate memory for a possible 'nvals' rows */
+ void sqlbuf_resize(struct sqlbuf *sbuf, unsigned int nvals);
Index: src/rtgtarg.y
===========================================================================
--- src/rtgtarg.y	2004/11/03 14:26:17	#2
+++ src/rtgtarg.y	2004/11/03 14:26:17
@@ -1,140 +1,203 @@
 %{
+/*
+ * (c) 2004 bill fumerola, yahoo!
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Yahoo$
+ */
+
+#include <err.h>
 #include "common.h"
 #include "rtg.h"
+#include "rtghash.h"
 
 int yyerror(const char *s);
 extern int yylineno, lineno;
 extern char *yytext;
 
-
-static host_t *thst;
+static struct config_snmphost thst;
+static struct host_struct *nhst;
 static target_t *ttgt;
+static struct tgthead htargets;
 
 #define YYDEBUG 1
 %}
 
 %union {
-      char *string;
-      unsigned long long number;
+	char *string;
+#ifdef HAVE_UNSIGNED_LONG_LONG
+	unsigned long long number;
+#else
+	unsigned long number;
+#endif
 }
 
-%token <string>               L_STRING
-%token <string>               L_IDENT
-%token <string>               L_IPADDR
-%token <string>               L_OID
-%token <number>               L_NUMBER
+%token <string>		L_STRING
+%token <string>		L_IDENT
+%token <string>		L_IPADDR
+%token <string>		L_OID
+%token <number>		L_NUMBER
 
 /* top level */
 %token T_HOST
 
 /* per-host */
-%token HST_COMM HST_SVER HST_TRGT
+%token HST_COMM HST_SVER HST_TRGT HST_PORT HST_TIME HST_RTRY
 
 /* per-target */
 %token TGT_BITS TGT_TBL TGT_ID TGT_SPEED TGT_DESCR
 
 %%
 
-config                :
-              | statements
-               ;
+config		:
+		| statements
+		;
 
-statements    : statements statement
-              | statement
-              ;
+statements	: statements statement
+	   	| statement
+		;
 
-statement     : host_entry
-              | error ';'
-                      { fprintf(stderr, "';' line %d\n", yylineno); yyerrok; }
-              | error '}'
-                      { fprintf(stderr, "'}' line %d\n", yylineno); yyerrok; }
-              ;
+statement	: host_entry
+	  	| error ';'
+			{ fprintf(stderr, "';' line %d\n", yylineno); yyerrok; }
+		| error '}'
+			{ fprintf(stderr, "'}' line %d\n", yylineno); yyerrok; }
+		;
 
-host_entry:   T_HOST L_IPADDR
+host_entry:	T_HOST L_IPADDR
 {
-      thst = malloc(sizeof(host_t));
-      bzero(thst, sizeof(host_t));
-      thst->host = $2;
+	bzero(&thst, sizeof(thst));
+	thst.host = $2;
+	thst.retries = 5;
+	thst.timeout = 5000000L;
+	RTGLL_INIT(&htargets);
 }
 '{' host_directives '}'
 {
-      thst = NULL;
+	nhst = host_insert(&thst);
+
+	while (!RTGLL_EMPTY(&htargets)) {
+		ttgt = RTGLL_FIRST(&htargets);
+		RTGLL_REMOVE_HEAD(&htargets, next);
+		ttgt->host = nhst;
+		tgthash_insert(thash, ttgt);
+	}
+};
+
+host_directives	: host_directives host_directive
+		| host_directive
+		;
+
+host_directive	: community_directive
+	        | sversion_directive
+		| sport_directive
+		| timeout_directive
+		| retries_directive
+		| target_entry
+		;
+
+community_directive	: HST_COMM L_IDENT
+{
+	thst.community = $2;
 };
 
-host_directives       : host_directives host_directive
-              | host_directive
-              ;
+sversion_directive	: HST_SVER L_NUMBER
+{
+	thst.snmp_ver = (unsigned short)$2;
+};
 
-host_directive        : comm_directive
-              | sver_directive
-              | target_entry
-              ;
+sport_directive		: HST_PORT L_NUMBER
+{
+	thst.snmp_port = (unsigned short)$2;
+};
 
-comm_directive        : HST_COMM L_IDENT
+timeout_directive	: HST_TIME L_NUMBER
 {
-      thst->community = $2;
+	/* microseconds(uS) to milliseconds(ms) */
+	thst.timeout = $2 * 1000;
 };
 
-sver_directive        : HST_SVER L_NUMBER
+retries_directive	: HST_RTRY L_NUMBER
 {
-      thst->snmp_ver = (unsigned short)$2;
+	thst.retries = $2;
 };
 
-target_entry  : HST_TRGT L_OID
+target_entry		: HST_TRGT L_OID
 {
-      ttgt = malloc(sizeof(target_t));
-      bzero(ttgt, sizeof(target_t));
-      ttgt->objoid = $2;
-      ttgt->host = thst;
-      ttgt->maxspeed = DEFAULT_OUT_OF_RANGE;
+	ttgt = malloc(sizeof(target_t));
+	bzero(ttgt, sizeof(target_t));
+	ttgt->objoid = $2;
+	ttgt->maxspeed = DEFAULT_OUT_OF_RANGE;
 }
 '{' tgt_directives '}'
 {
-      add_hash_entry(ttgt);
-      ttgt = NULL;
+	/* XXX - depends on directives coming before targets */
+	RTGLL_INSERT_HEAD(&htargets, ttgt, next);
+	ttgt = NULL;
 };
-tgt_directives        : tgt_directives tgt_directive
-              | tgt_directive
-              ;
+
+tgt_directives	: tgt_directives tgt_directive
+		| tgt_directive
+		;
 
-tgt_directive : bits_directive
-              | table_directive
-              | id_directive
-              | speed_directive
-              | descr_directive
-              ;
+tgt_directive	: bits_directive
+		| table_directive
+		| id_directive
+		| speed_directive
+		| descr_directive
+		;
 
-bits_directive        : TGT_BITS L_NUMBER
+bits_directive	: TGT_BITS L_NUMBER
 {
-      ttgt->bits = $2;
+	ttgt->bits = $2;
 };
 
-table_directive       : TGT_TBL L_IDENT
+table_directive	: TGT_TBL L_IDENT
 {
-      ttgt->table = $2;
+	ttgt->dbt = dbtable_insert($2);
 };
 
-id_directive  : TGT_ID L_NUMBER
+id_directive	: TGT_ID L_NUMBER
 {
-      ttgt->iid = $2;
+	ttgt->iid = $2;
 };
 
-speed_directive       : TGT_SPEED L_NUMBER
+speed_directive	: TGT_SPEED L_NUMBER
 {
-      ttgt->maxspeed = $2;
+	ttgt->maxspeed = $2;
 };
 
-descr_directive       : TGT_DESCR L_STRING
+descr_directive	: TGT_DESCR L_STRING
 {
-      ttgt->description = $2;
+	ttgt->description = $2;
 };
 
 %%
 int yyerror(const char *msg)
 {
 
-      fprintf(stderr, "targets failure on line %d - %s\n", lineno, msg);
-      fprintf(stderr, "last token parsed: %s\n", yytext);
+	fprintf(stderr, "targets failure on line %d - %s\n", lineno, msg);
+	fprintf(stderr, "last token parsed: %s\n", yytext);
 
-      exit(1);
+	exit(1);
 }
